Page MenuHomePhabricator

Some styles specific to Vector skin missing (Special:Preferences, mediawiki.notification bubbles, jQuery UI)
Closed, ResolvedPublic

Description

http://en.wikipedia.beta.wmflabs.org/wiki/Special:Preferences lacks full styling for tabs most of the time I visit that page. I haven't been able to figure out a pattern, but it's annoying. There are no errors in developer console nor any failed http requests.

Event Timeline

Nikerabbit raised the priority of this task from to Needs Triage.
Nikerabbit updated the task description. (Show Details)
Nikerabbit added a subscriber: Nikerabbit.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 18 2015, 9:13 AM
greg triaged this task as Normal priority.Mar 18 2015, 3:31 PM
greg set Security to None.
greg added a subscriber: greg.

The only thing I can think of is if a BetaFeatures is causing this.

Jdforrester-WMF added subscribers: ori, Jdforrester-WMF.

This feels like it might possibly be caused by the recent ResourceLoader change by @ori to resequence module loading? Random guess, but it's the only thing I know of that's changed lately.

Krinkle added a subscriber: Krinkle.EditedMar 18 2015, 3:57 PM

These tab styles are provided by mediawiki.special.preferences.less from the Vector skin, added to the mediawiki.special.preferences core module (which doesn't have these tab styles).

It looks like these extra skin styles are not being loaded somehow.

http://bits.wikimedia.org/en.wikipedia.org/load.php?lang=en&modules=mediawiki.special.preferences&only=styles&skin=vector
http://bits.beta.wmflabs.org/en.wikipedia.beta.wmflabs.org/load.php?lang=en&modules=mediawiki.special.preferences&only=styles&skin=vector

Compare to e.g.
http://bits.wikimedia.org/www.mediawiki.org/load.php?lang=en&modules=mediawiki.special.preferences&only=styles&skin=vector

The one for en.wikipedia.org only serves MediaWiki core's mediawiki.special.preferences.css. The one for mediawiki.org does contain Vector's additional styles.

Same on testwiki and test2wiki, btw.

This has now hit production. https://en.wikipedia.org/wiki/Special:Preferences.

It seems de.wikipedia.org and www.wikidata.org are not affected, however. See my previous reply for the exact observation. I haven't found a cause yet.

TheDJ added a subscriber: TheDJ.Apr 2 2015, 8:24 AM

This has now progressed towards en.wp production: T94808

Krinkle renamed this task from http://en.wikipedia.beta.wmflabs.org/wiki/Special:Preferences lacks normal styling to Special:Preferences is missing Vector styles for mediawiki.special.preferences .Apr 2 2015, 8:25 AM
Krinkle raised the priority of this task from Normal to High.
Krinkle updated the task description. (Show Details)

Change 201501 had a related patch set uploaded (by Aude):
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201501

and possibly also causing T94518

Jdlrobson claimed this task.Apr 2 2015, 6:43 PM
Jdlrobson added a project: Gather.

I've put this on the swat deploy calendar: https://wikitech.wikimedia.org/w/index.php?title=Deployments&diff=151887&oldid=151884
Will get this merged asap

Ugh, you're not supposed to use $wgResourceModuleSkinStyles in extensions… it's for skins. I'm not sure if the proposed patch will even work, adding $wgGatherMobileSpecialPageResourceBoilerplate will probably continue to mess stuff up. You should have your own RL module with styles, and use the skinStyles option to define styles for Vector only.

Yay hooks and globals! ;-)
Sounds like another task to prevent extensions manipulating this erroneously... note MobileFrontend also uses this global.

MobileFrontend is probably within its rights to do it, since it has the Minerva skin inside. If it's using $wgResourceModuleSkinStyles['minerva'] only, it's good.

... yeh but we should at least have some kind of wrapper for this. I'm guessing a hook would be better than a global since this can apparently do catastrophic things?

matmarex renamed this task from Special:Preferences is missing Vector styles for mediawiki.special.preferences to Some styles specific to Vector skin missing (Special:Preferences, mediawiki.notification bubbles, jQuery UI).Apr 2 2015, 6:55 PM

Well, stuff breaks when you clobber globals, news at eleven. It's a chicken-and-egg problem: if we use a hook, someone could clobber $wgHooks. We must have some faith in developers :) Instead I documented it better: https://www.mediawiki.org/w/index.php?title=Manual:$wgResourceModuleSkinStyles&diff=1511052&oldid=1415414

Change 201503 had a related patch set uploaded (by Jdlrobson):
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201503

Change 201501 merged by jenkins-bot:
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201501

Change 201581 had a related patch set uploaded (by Jdlrobson):
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201581

Change 201503 merged by jenkins-bot:
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201503

Change 201581 merged by jenkins-bot:
Fix overriding of vector styles in resources definition

https://gerrit.wikimedia.org/r/201581

Krinkle closed this task as Resolved.Apr 3 2015, 5:29 AM
Krinkle removed a project: Patch-For-Review.
JKatzWMF moved this task from Needs triage to Product triage on the Gather board.Apr 11 2015, 12:02 AM
JKatzWMF moved this task from Product triage to In sprint on the Gather board.Apr 11 2015, 12:07 AM